
#INCLUDE "libraries\iniobject\inifile.bi"
#UNDEF true
#UNDEF false
#INCLUDE "libraries\sgui\sgui.bas"
#UNDEF black
#UNDEF white
#INCLUDE "libraries\sgui\checkmarkgadget.bas"
#INCLUDE "libraries\sgui\simplegadget.bas"
#INCLUDE "libraries\sgui\messagebox.bas"
#INCLUDE "libraries\colors\colors.bi"
#UNDEF black
#UNDEF white
#INCLUDE "colors.bas"
#INCLUDE "videogrid.bas"
#INCLUDE "grid.bas"

USING inifobj

CONST engine = "engine2.exe"

CONST s1 = "Four-in-a-row"
CONST s2 = "Welcome !"
CONST s3 = "Engine not found !"
CONST s4 = "Grid full !"
CONST s5 = "Black wins !"
CONST s6 = "White wins !"
CONST s7 = "Start another game ?"
CONST s8 = "Game over"

DECLARE SUB Display(AS STRING)
DECLARE FUNCTION EmptyCell(AS tGrid, AS INTEGER) AS INTEGER
DECLARE FUNCTION EngineMove(AS STRING) AS INTEGER
DECLARE SUB ReadIniFile(BYREF AS INTEGER, BYREF AS INTEGER)
DECLARE FUNCTION Exists(file AS STRING) AS INTEGER
DECLARE SUB InsertAndCheckGameState
DECLARE SUB Restart

SCREENRES 8 * 48, 10 * 48, 32
WIDTH (8 * 48) \ 8, (10 * 48) \ 16
WINDOWTITLE s1
InitGFX
COLOR , windowColor
CLS

DIM SHARED AS EventHandle PTR event
event = CreateEventHandle

DIM AS Gadget PTR b1, b2, b3, b4, b5, b6, b7
b1 = AddSimpleGadget(event, 0 * 48 + 4 + 24, 9 * 48 + 12, 40, 24, "A")
b2 = AddSimpleGadget(event, 1 * 48 + 4 + 24, 9 * 48 + 12, 40, 24, "B")
b3 = AddSimpleGadget(event, 2 * 48 + 4 + 24, 9 * 48 + 12, 40, 24, "C")
b4 = AddSimpleGadget(event, 3 * 48 + 4 + 24, 9 * 48 + 12, 40, 24, "D")
b5 = AddSimpleGadget(event, 4 * 48 + 4 + 24, 9 * 48 + 12, 40, 24, "E")
b6 = AddSimpleGadget(event, 5 * 48 + 4 + 24, 9 * 48 + 12, 40, 24, "F")
b7 = AddSimpleGadget(event, 6 * 48 + 4 + 24, 9 * 48 + 12, 40, 24, "G")
GadgetOn(b1, b7)

DIM SHARED v AS tVideoGrid
DIM SHARED g AS tGrid
DIM SHARED p AS piece = white
DIM SHARED AS INTEGER x, y
DIM SHARED h AS STRING
DIM SHARED AS INTEGER whitePoints = 0, blackPoints = 0

DIM AS INTEGER CPW, CPB
ReadIniFile(CPW, CPB)

h = ""
g.Empty
v.Initialize(48, 20, 0, 48, gridColor, noPieceColor, whitePieceColor, blackPieceColor)
v.DrawGrid

IF Exists(engine) OR ((CPW = 0) AND (CPB = 0)) THEN
  Display(s2)
ELSE
  Display(s3)
  SLEEP
  DestroyEventHandle(event)
  END
END IF

DO
  event->xSleep(1)
  IF event->GADGETMESSAGE THEN
    SELECT CASE event->GADGETMESSAGE
      CASE b1 : x = 1
      CASE b2 : x = 2
      CASE b3 : x = 3
      CASE b4 : x = 4
      CASE b5 : x = 5
      CASE b6 : x = 6
      CASE b7 : x = 7
    END SELECT
    y = EmptyCell(g, x)
    IF (x > 0) ANDALSO (y > 0) THEN
      InsertAndCheckGameState
    END IF
  END IF
  IF ((p = white) AND (CPW = 1)) OR ((p = black) AND (CPB = 1)) THEN
    x = EngineMove(h)
    y = EmptyCell(g, x)
    InsertAndCheckGameState
  END IF
LOOP UNTIL event->EXITEVENT

DestroyEventHandle(event)
END

SUB Display(s AS STRING)
  FillA(24, 12, 7 * 48, 24, windowColor, 1)
  DRAW STRING((7 * 48 - 8 * LEN(s)) \ 2 + 24, 12 + 4), s, textColor
END SUB

FUNCTION EmptyCell(aGrid AS tGrid, aCol AS INTEGER) AS INTEGER
  DIM AS INTEGER result = 0
  DIM AS INTEGER y = 0
  WHILE (y < 6) AND (result = 0)
    y += 1
    IF aGrid.array(aCol, y) = nothing THEN result = y
  WEND
  FUNCTION = result
END FUNCTION

FUNCTION EngineMove(h AS STRING) AS INTEGER
  DIM n AS UBYTE = FREEFILE
  OPEN PIPE engine & " " & h FOR INPUT AS #n
  DIM AS STRING l
  LINE INPUT #n, l
  CLOSE #n
  FUNCTION = AscToInt(l[0])
END FUNCTION

SUB ReadIniFile(BYREF aCPW AS INTEGER, BYREF aCPB AS INTEGER)
  DIM myIni AS iniobj = iniobj("options.ini")
  SELECT CASE myIni.ReadString("players", "white", "")
  	CASE "computer"
  		aCPW = 1
  	CASE "user"
  		aCPW = 0
  	CASE ELSE
  		aCPW = 0
  END SELECT
  SELECT CASE myIni.ReadString("players", "black", "")
  	CASE "computer"
  		aCPB = 1
  	CASE "user"
  		aCPB = 0
  	CASE ELSE
  		aCPB = 1
  END SELECT
END SUB

FUNCTION Exists(file AS STRING) AS INTEGER
  RETURN (LEN(DIR(file)) > 0) OR (LEN(DIR(file & ".exe")) > 0)
END FUNCTION

SUB InsertAndCheckGameState
  DIM s AS STRING
  v.InsertPiece(x, y, IIF(p=white, whitePieceColor, blackPieceColor))
  g.Insert(p, x)
  p *= black
  h += STR(x)
  x = 0
  whitePoints = g.GridPoints(white)
  blackPoints = g.GridPoints(black)
  IF (whitePoints >= 4) OR (blackPoints >= 4) OR g.IsFull THEN
    IF g.IsFull THEN s = s4
    IF g.GridPoints(black) >= 4 THEN s = s5
    IF g.GridPoints(white) >= 4 THEN s = s6
    s = s & "|" & s7
    IF MessageBox(12, 48 + 12, s, s8, MBType_YESNO) = MBButton_YES THEN
      Restart
    ELSE
      event->EXITEVENT = 1
    END IF
  END IF
END SUB

SUB Restart
  p = white
  h = ""
  whitePoints = 0
  blackPoints = 0
  g.Empty
  v.DrawGrid
END SUB
