
#INCLUDE "libraries\iniobject\inifile.bi"
#INCLUDE "libraries\sgui\sgui.bas"
#INCLUDE "libraries\sgui\checkmarkgadget.bas"
#INCLUDE "libraries\sgui\simplegadget.bas"

USING inifobj

DECLARE SUB ReadIniFile(BYREF AS INTEGER, BYREF AS INTEGER)
DECLARE SUB UpdateIniFile(BYVAL AS INTEGER, BYVAL AS INTEGER)

SCREENRES 320, 240, 32, 1, &h04
WIDTH 320\8, 240\16
WINDOWTITLE "Game option"

InitGFX

DIM AS INTEGER CPW, CPB
ReadIniFile(CPW, CPB)

DIM AS EventHandle PTR event
event = CreateEventHandle

DIM AS Gadget PTR check1, check2, button1, button2
check1 = AddCheckMarkGadget(event, 60, 60, CPW, "Computer plays White")
check2 = AddCheckMarkGadget(event, 60, 90, CPB, "Computer plays Black")
button1 = AddSimpleGadget(event, 60, 150, 200, 20, "Ok")
button2 = AddSimpleGadget(event, 60, 180, 200, 20, "Cancel")

GadgetOn(check1, button2)

DO
  event->xSleep(1)
  IF event->GADGETMESSAGE THEN
    SELECT CASE event->GADGETMESSAGE
      CASE check1
        CPW = GetSelect(check1)
      CASE check2
        CPB = GetSelect(check2)
      CASE button1
        UpdateIniFile(CPW, CPB)
        SHELL "start game.exe"
        event->EXITEVENT = 1
      CASE button2
        event->EXITEVENT = 1
    END SELECT
  END IF
LOOP UNTIL event->EXITEVENT

DestroyEventHandle(event)
END

SUB ReadIniFile(BYREF aCPW AS INTEGER, BYREF aCPB AS INTEGER)
  DIM myIni AS iniobj = iniobj("options.ini")
  DIM modify AS INTEGER = 0
  SELECT CASE myIni.ReadString("players", "white", "")
  	CASE "computer"
  		aCPW = 1
  	CASE "user"
  		aCPW = 0
  	CASE ELSE
  		aCPW = 0
  END SELECT
  SELECT CASE myIni.ReadString("players", "black", "")
  	CASE "computer"
  		aCPB = 1
  	CASE "user"
  		aCPB = 0
  	CASE ELSE
  		aCPB = 1
  END SELECT
END SUB

SUB UpdateIniFile(BYVAL aCPW AS INTEGER, BYVAL aCPB AS INTEGER)
  DIM myIni AS iniobj = iniobj("options.ini")
  DIM AS STRING sCPW = IIF(aCPW = 0, "user", "computer")
  DIM AS STRING sCPB = IIF(aCPB = 0, "user", "computer")
  myIni.WriteString("players", "white", sCPW)
  myIni.WriteString("players", "black", sCPB)
  myIni.UpdateFile()
END SUB
